-- Para instalar el paquete DBMS_FGA hay que acceder como usuario SYS y ejecutar el fichero:
-- C:\oraclexe\app\oracle\product\11.2.0\server\rdbms\admin\dbmsfga.sql
-- ****************************************************************************
-- audit_trail especifica donde se guardar el log de la auditora
-- Si audit_trail incluye la BBDD, el log se guardar en la tabla  SYS.FGA_LOG$
-- ****************************************************************************
ALTER SYSTEM SET audit_trail = "ADMIN_BBDD" SCOPE=SPFILE;
-- Activamos para guardar el log de inserciones, actualizaciones y borrados
SET serveroutput ON;
SET serveroutput ON size 1000000;
DECLARE
  contador_1     NUMBER := 0;
  contador_2     NUMBER := 0;
  nombre_tabla VARCHAR(40);
  esquema     VARCHAR (40) := 'ADMIN_BBDD';
BEGIN
  esquema    := UPPER(esquema);
  FOR tablas IN
  ( SELECT owner, table_name FROM dba_tables WHERE owner LIKE esquema
  )
  LOOP
    contador_1     := contador_1+1;
    nombre_tabla := tablas.table_name;
    BEGIN
      dbms_output.put_line(tablas.owner||'."'||tablas.table_name||'"');
      EXECUTE immediate 'AUDIT UPDATE,DELETE,INSERT ON '||tablas.owner||'."'||tablas.table_name||'" by access';
    EXCEPTION       
    WHEN OTHERS THEN 
      dbms_output.put_line('Numero de error: '||SQLCODE);
      dbms_output.put_line('Mensaje: '||SUBSTR(SQLERRM, 1, 100));
      dbms_output.put_line('Tabla: '||nombre_tabla);
      contador_1:= contador_1-1;
    END;
  END LOOP;
  dbms_output.put_line('*******************************************');
  dbms_output.put_line('El nmero de tablas auditadas es: '||contador_1);
  dbms_output.put_line('*******************************************');
END;
/
--Preparacin del monitoreo minucioso FGA
SET serveroutput ON;
SET serveroutput ON size 1000000;
DECLARE
  contador_1     NUMBER := 0;
  contador_2     NUMBER := 0;
  nombre_tabla VARCHAR(40);
  esquema     VARCHAR(40) := 'ADMIN_BBDD';
  nombre_politica VARCHAR (40);
BEGIN
  esquema    := UPPER(esquema);
  FOR tablas IN
  ( SELECT owner, table_name FROM dba_tables WHERE owner LIKE esquema
  )
  LOOP
    contador_1     := contador_1+1;
    nombre_tabla := tablas.table_name;
    nombre_politica := 'politica_de_'||nombre_tabla;
    BEGIN
      dbms_output.put_line(tablas.owner||'."'||tablas.table_name||'"');
	  -- Creamos la poltica de la auditora
	  -- Parmetros:
	  -- ::: object_schema --> nombre del esquema que ser auditado
	  -- ::: object_name -->  nombre del objeto que auditamos
	  -- ::: policy_name --> nombre de la poltica que creamos
	  -- ::: enable --> habilitacin de la poltica. boolean normalmente a TRUE
      EXECUTE immediate 'DBMS_FGA.ADD_POLICY (object_schema => '||esquema||', object_name => '||tablas.owner||'."'||tablas.table_name||'" , policy_name => '||nombre_politica||', enable => TRUE)';
    EXCEPTION        
    WHEN OTHERS THEN  
      dbms_output.put_line('Nmero de error: '||SQLCODE);
      dbms_output.put_line('Mensage: '||SUBSTR(SQLERRM, 1, 100));
      dbms_output.put_line('Esquema: '||esquema);
      dbms_output.put_line('Object Name: '||tablas.owner||'.'||tablas.table_name);
      dbms_output.put_line('Tabla: '||nombre_tabla);
      contador_1:= contador_1-1;
    END;
  END LOOP;
  dbms_output.put_line('************************************************');
  dbms_output.put_line('El nmero de tablas auditadas minuciosamente es: '||contador_1);
  dbms_output.put_line('************************************************');
END;
/