--ESQUEMA 
-- PRIVILEGIOS DEL USUARIO ADMIN_BBDD SOBRE LAS TABLAS
set serveroutput on;
set serveroutput on size 1000000;

DECLARE
contador_1 number := 0;
contador_2 number := 0;
v_tablename varchar2(32);
nombre_esquema varchar2(30) := 'ADMIN_BBDD';
nombre_usuario varchar2(30) := 'ADMIN_BBDD';

BEGIN

nombre_esquema := UPPER(nombre_esquema);
nombre_usuario := UPPER(nombre_usuario);

for tablas in ( select owner, table_name from dba_tables where owner like nombre_esquema )
loop
contador_1:= contador_1+1;
v_tablename := tablas.table_name;
begin
dbms_output.put_line(tablas.owner||'."'||tablas.table_name||'"');
execute immediate 'grant select,update, insert,delete on "'||tablas.owner||'"."'||tablas.table_name||'" to '||nombre_usuario;
EXCEPTION -- exception handlers begin
WHEN OTHERS THEN -- handles all other errors
dbms_output.put_line('Nmero de error: '||SQLCODE);
dbms_output.put_line('Mensaje de error: '||SUBSTR(SQLERRM, 1, 100));
dbms_output.put_line('Nombre de la tabla: '||v_tablename);
contador_1:= contador_1-1;
END;
end loop;

dbms_output.put_line('***************************');
dbms_output.put_line('El nmero de tablas autorizadas a ADMIN_BBDD es: '||contador_1);
dbms_output.put_line('***************************');

END;
/



--PRIVILEGIOS DEL USUARIO USUARIO_BBDD SOBRE LAS TABLAS
set serveroutput on;
set serveroutput on size 1000000;

DECLARE
contador_1 number := 0;
contador_2 number := 0;
v_tablename varchar2(32);
nombre_esquema varchar2(30) := 'ADMIN_BBDD';
nombre_usuario varchar2(30) := 'USUARIO_BBDD';


BEGIN

nombre_esquema := UPPER(nombre_esquema);
nombre_usuario := UPPER(nombre_usuario);

for tablas in ( select owner, table_name from dba_tables where owner like nombre_esquema )
loop
contador_1:= contador_1+1;
v_tablename := tablas.table_name;
begin
dbms_output.put_line(tablas.owner||'."'||tablas.table_name||'"');
execute immediate 'grant select on "'||tablas.owner||'"."'||tablas.table_name||'" to '||nombre_usuario;
EXCEPTION 
WHEN OTHERS THEN 
dbms_output.put_line('Nmero de error: '||SQLCODE);
dbms_output.put_line('Mensaje de error: '||SUBSTR(SQLERRM, 1, 100));
dbms_output.put_line('Nombre de tabla: '||v_tablename);
contador_1:= contador_1-1;
END;
end loop;

dbms_output.put_line('********************************');
dbms_output.put_line('El nmero de tablas autorizadas a USUARIO_BBDD es: '||contador_1);
dbms_output.put_line('********************************');

END;
/


-- PERMISOS DEL USUARIO ADMIN_BBDD SOBRE LOS PROCEDIMEINTOS
set serveroutput on;
set serveroutput on size 1000000;

DECLARE
contador_1 number := 0;
contador_2 number := 0;
nombre_entidad varchar2(32);
nombre_esquema varchar2(30) := 'ADMIN_BBDD';
nombre_usuario varchar2(30) := 'ADMIN_BBDD';


BEGIN

nombre_esquema := UPPER(nombre_esquema);
nombre_usuario := UPPER(nombre_usuario);

for procedimientos in (select owner, object_name from dba_procedures where owner like nombre_esquema )
loop
contador_1:= contador_1+1;
nombre_entidad := procedimientos.object_name;
begin
dbms_output.put_line(procedimientos.owner||'."'||procedimientos.object_name||'"');
execute immediate 'grant execute on "'||procedimientos.owner||'"."'||procedimientos.object_name||'" to '||nombre_usuario;
EXCEPTION -- exception handlers begin
WHEN OTHERS THEN -- handles all other errors
dbms_output.put_line('Nmero de error: '||SQLCODE);
dbms_output.put_line('Mensaje de error: '||SUBSTR(SQLERRM, 1, 100));
dbms_output.put_line('Nombre del procedimiento: '||nombre_entidad);
contador_1:= contador_1-1;
END;
end loop;

dbms_output.put_line('************************');
dbms_output.put_line('El nmero de procedimientos autorizados a ADMIN_BBDD es: '||contador_1);
dbms_output.put_line('************************');

END;
/



-- PERMISOS DEL USUARIO USUARIO_BBDD SOBRE LOS PROCEDIMEINTOS
set serveroutput on;
set serveroutput on size 1000000;

DECLARE
contador_1 number := 0;
contador_2 number := 0;
nombre_entidad varchar2(32);
nombre_esquema varchar2(30) := 'ADMIN_BBDD';
nombre_usuario varchar2(30) := 'USUARIO_BBDD';

BEGIN

nombre_esquema := UPPER(nombre_esquema);
nombre_usuario := UPPER(nombre_usuario);

for procedimientos in (select owner, object_name from dba_procedures where owner like nombre_esquema)
loop
contador_1:= contador_1+1;
nombre_entidad := procedimientos.object_name;
begin
dbms_output.put_line(procedimientos.owner||'."'||procedimientos.object_name||'"');
execute immediate 'grant execute on "'||procedimientos.owner||'"."'||procedimientos.object_name||'" to '||nombre_usuario;
EXCEPTION -- exception handlers begin
WHEN OTHERS THEN -- handles all other errors
dbms_output.put_line('Nmero de error: '||SQLCODE);
dbms_output.put_line('Mensaje de error: '||SUBSTR(SQLERRM, 1, 100));
dbms_output.put_line('Nombre del procedimiento: '||nombre_entidad);
contador_1:= contador_1-1;
END;
end loop;

dbms_output.put_line('**************************');
dbms_output.put_line('EL NMERO DE PROCEDIMIENTOS AUTORIZADOS A USUARIO_BBDD ES: '||contador_1);
dbms_output.put_line('**************************');

END;
/
