DROP TABLE ADMIN_BBDD.Curriculo CASCADE CONSTRAINTS 
;
DROP TABLE ADMIN_BBDD.Direccion CASCADE CONSTRAINTS 
;
DROP TABLE ADMIN_BBDD.Empleo CASCADE CONSTRAINTS 
;
DROP TABLE ADMIN_BBDD.Empresa CASCADE CONSTRAINTS 
;
DROP TABLE ADMIN_BBDD.Entrevista CASCADE CONSTRAINTS 
;
DROP TABLE ADMIN_BBDD.Experiencia CASCADE CONSTRAINTS 
;
DROP TABLE ADMIN_BBDD.Idioma CASCADE CONSTRAINTS 
;
DROP TABLE ADMIN_BBDD.Idiomas CASCADE CONSTRAINTS 
;
DROP TABLE ADMIN_BBDD.Oferta CASCADE CONSTRAINTS 
;
DROP TABLE ADMIN_BBDD.Pais CASCADE CONSTRAINTS 
;
DROP TABLE ADMIN_BBDD.Persona CASCADE CONSTRAINTS 
;
DROP TABLE ADMIN_BBDD.Poblacion CASCADE CONSTRAINTS 
;
DROP TABLE ADMIN_BBDD.Puesto CASCADE CONSTRAINTS 
;
DROP TABLE ADMIN_BBDD.Tipo_puesto CASCADE CONSTRAINTS 
;
DROP TABLE ADMIN_BBDD.Tipo_via CASCADE CONSTRAINTS 
;
DROP TABLE ADMIN_BBDD.Trabajador CASCADE CONSTRAINTS 
;

CREATE TABLE ADMIN_BBDD.Curriculo 
    ( 
     id_curriculo NUMBER  NOT NULL , 
     fecha DATE  NOT NULL , 
     foto BLOB , 
     id_trabajador NUMBER  NOT NULL 
    ) TABLESPACE ESPACIO_ESP 
    LOGGING 
;


CREATE UNIQUE INDEX ADMIN_BBDD.Curriculo__IDXv1 ON ADMIN_BBDD.Curriculo 
    ( 
     id_trabajador ASC 
    ) 
    LOGGING 
;

ALTER TABLE ADMIN_BBDD.Curriculo 
    ADD CONSTRAINT "Curriculo PK" PRIMARY KEY ( id_curriculo ) ;



CREATE TABLE ADMIN_BBDD.Direccion 
    ( 
     id_direccion NUMBER  NOT NULL , 
     id_tipo NUMBER  NOT NULL , 
     nombre VARCHAR2 (30)  NOT NULL , 
     numero NUMBER , 
     piso NUMBER , 
     puerta VARCHAR2 (2) , 
     cp NUMBER  NOT NULL
    ) TABLESPACE ESPACIO_ESP 
    LOGGING 
;



ALTER TABLE ADMIN_BBDD.Direccion 
    ADD CONSTRAINT "Direccion PK" PRIMARY KEY ( id_direccion ) ;



CREATE TABLE ADMIN_BBDD.Empleo 
    ( 
     id_empleo NUMBER  NOT NULL , 
     nom_empresa VARCHAR2 (30)  NOT NULL , 
     fecha_inicio DATE  NOT NULL , 
     fecha_fin DATE , 
     id_puesto NUMBER  NOT NULL , 
     id_curriculo NUMBER  NOT NULL 
    ) TABLESPACE ESPACIO_ESP 
    LOGGING 
;



ALTER TABLE ADMIN_BBDD.Empleo 
    ADD CONSTRAINT "Empleo PK" PRIMARY KEY ( id_empleo ) ;



CREATE TABLE ADMIN_BBDD.Empresa 
    ( 
     id_empresa NUMBER  NOT NULL , 
     cif VARCHAR2 (15)  NOT NULL , 
     nombre VARCHAR2 (30)  NOT NULL , 
     email VARCHAR2 (30) , 
     telefono NUMBER  NOT NULL , 
     id_direccion NUMBER  NOT NULL, 
     id_persona NUMBER NOT NULL
    ) TABLESPACE ESPACIO_ESP 
    LOGGING 
;


CREATE UNIQUE INDEX ADMIN_BBDD.Empresa__IDXv1 ON ADMIN_BBDD.Empresa 
    ( 
     id_direccion ASC 
    ) 
    LOGGING 
;

ALTER TABLE ADMIN_BBDD.Empresa 
    ADD CONSTRAINT "Empresa PK" PRIMARY KEY ( id_empresa ) ;



CREATE TABLE ADMIN_BBDD.Entrevista 
    ( 
     id_Entrevista NUMBER  NOT NULL , 
     fecha DATE  NOT NULL , 
     id_oferta NUMBER  NOT NULL , 
     id_trabajador NUMBER  NOT NULL 
    ) TABLESPACE ESPACIO_ESP 
    LOGGING 
;



ALTER TABLE ADMIN_BBDD.Entrevista 
    ADD CONSTRAINT "Entrevista PK" PRIMARY KEY ( id_Entrevista ) ;



CREATE TABLE ADMIN_BBDD.Experiencia 
    ( 
     id_Experiencia NUMBER  NOT NULL , 
     id_oferta NUMBER  NOT NULL , 
     id_puesto NUMBER  NOT NULL 
    ) TABLESPACE ESPACIO_ESP 
    LOGGING 
;


CREATE UNIQUE INDEX ADMIN_BBDD.Experiencia__IDXv1 ON ADMIN_BBDD.Experiencia 
    ( 
     id_puesto ASC 
    ) 
    LOGGING 
;
CREATE UNIQUE INDEX ADMIN_BBDD.Experiencia__IDXv2 ON ADMIN_BBDD.Experiencia 
    ( 
     id_oferta ASC 
    ) 
    LOGGING 
;

ALTER TABLE ADMIN_BBDD.Experiencia 
    ADD CONSTRAINT "Experiencia PK" PRIMARY KEY ( id_Experiencia ) ;



CREATE TABLE ADMIN_BBDD.Idioma 
    ( 
     id_idioma NUMBER  NOT NULL , 
     nivel VARCHAR2 (10)  NOT NULL , 
     id_idiomas NUMBER , 
     id_curriculo NUMBER 
    ) TABLESPACE ESPACIO_ESP 
    LOGGING 
;



ALTER TABLE ADMIN_BBDD.Idioma 
    ADD CONSTRAINT "Idioma PK" PRIMARY KEY ( id_idioma ) ;



CREATE TABLE ADMIN_BBDD.Idiomas 
    ( 
     id_idiomas NUMBER  NOT NULL , 
     descripcion VARCHAR2 (25)  NOT NULL 
    ) TABLESPACE ESPACIO_ESP 
    LOGGING 
;



ALTER TABLE ADMIN_BBDD.Idiomas 
    ADD CONSTRAINT "Idiomas PK" PRIMARY KEY ( id_idiomas ) ;



CREATE TABLE ADMIN_BBDD.Oferta 
    ( 
     id_oferta NUMBER  NOT NULL , 
     remuneracion NUMBER  NOT NULL , 
     prioridad NUMBER  NOT NULL , 
     fecha_inicio DATE  NOT NULL , 
     fecha_adjudicacion DATE , 
     id_puesto NUMBER  NOT NULL , 
     id_empresa NUMBER  NOT NULL 
    ) TABLESPACE ESPACIO_ESP 
    LOGGING 
;


CREATE UNIQUE INDEX ADMIN_BBDD.Oferta__IDXv1 ON ADMIN_BBDD.Oferta 
    ( 
     id_puesto ASC 
    ) 
    LOGGING 
;

ALTER TABLE ADMIN_BBDD.Oferta 
    ADD CONSTRAINT "Oferta PK" PRIMARY KEY ( id_oferta ) ;



CREATE TABLE ADMIN_BBDD.Pais 
    ( 
     id_pais NUMBER  NOT NULL , 
     nombre VARCHAR2 (30)  NOT NULL 
    ) TABLESPACE ESPACIO_ESP 
    LOGGING 
;



ALTER TABLE ADMIN_BBDD.Pais 
    ADD CONSTRAINT "Pais PK" PRIMARY KEY ( id_pais ) ;



CREATE TABLE ADMIN_BBDD.Persona 
    ( 
     id_persona NUMBER  NOT NULL , 
     nif VARCHAR2 (12)  NOT NULL , 
     nombre VARCHAR2 (30)  NOT NULL , 
     apellido_1 VARCHAR2 (30)  NOT NULL , 
     apellido_2 VARCHAR2 (30)  NOT NULL , 
     email VARCHAR2 (50) , 
     telefono NUMBER , 
     id_direccion NUMBER 
    ) TABLESPACE ESPACIO_ESP 
    LOGGING 
;


CREATE UNIQUE INDEX ADMIN_BBDD.Persona__IDXv1 ON ADMIN_BBDD.Persona 
    ( 
     id_direccion ASC 
    ) 
    LOGGING 
;

ALTER TABLE ADMIN_BBDD.Persona 
    ADD CONSTRAINT "Persona PK" PRIMARY KEY ( id_persona ) ;



CREATE TABLE ADMIN_BBDD.Poblacion 
    ( 
     cp NUMBER  NOT NULL , 
     nombre VARCHAR2 (30) , 
     id_pais NUMBER 
    ) TABLESPACE ESPACIO_ESP 
    LOGGING 
;



ALTER TABLE ADMIN_BBDD.Poblacion 
    ADD CONSTRAINT "Poblacion PK" PRIMARY KEY ( cp ) ;



CREATE TABLE ADMIN_BBDD.Puesto 
    ( 
     id_puesto NUMBER  NOT NULL , 
     descripcion VARCHAR2 (30)  NOT NULL , 
     id_tipo NUMBER  NOT NULL 
    ) TABLESPACE ESPACIO_ESP 
    LOGGING 
;



ALTER TABLE ADMIN_BBDD.Puesto 
    ADD CONSTRAINT "Puesto PK" PRIMARY KEY ( id_puesto ) ;



CREATE TABLE ADMIN_BBDD.Tipo_puesto 
    ( 
     id_tipo NUMBER  NOT NULL , 
     descripcion VARCHAR2 (30)  NOT NULL 
    ) TABLESPACE ESPACIO_ESP 
    LOGGING 
;



ALTER TABLE ADMIN_BBDD.Tipo_puesto 
    ADD CONSTRAINT "Tipo_puesto PK" PRIMARY KEY ( id_tipo ) ;



CREATE TABLE ADMIN_BBDD.Tipo_via 
    ( 
     id_tipo NUMBER  NOT NULL , 
     descripcion VARCHAR2 (25) 
    ) TABLESPACE ESPACIO_ESP 
    LOGGING 
;



ALTER TABLE ADMIN_BBDD.Tipo_via 
    ADD CONSTRAINT "Tipo_via PK" PRIMARY KEY ( id_tipo ) ;



CREATE TABLE ADMIN_BBDD.Trabajador 
    ( 
     id_trabajador NUMBER  NOT NULL , 
     nass VARCHAR2 (15)  NOT NULL , 
     id_persona NUMBER 
    ) TABLESPACE ESPACIO_ESP 
    LOGGING 
;


CREATE UNIQUE INDEX ADMIN_BBDD.Trabajador__IDXv1 ON ADMIN_BBDD.Trabajador 
    ( 
     id_persona ASC 
    ) 
    LOGGING 
;

ALTER TABLE ADMIN_BBDD.Trabajador 
    ADD CONSTRAINT "Trabajador PK" PRIMARY KEY ( id_trabajador ) ;




ALTER TABLE ADMIN_BBDD.Empleo 
    ADD CONSTRAINT Relation_12 FOREIGN KEY 
    ( 
     id_curriculo
    ) 
    REFERENCES ADMIN_BBDD.Curriculo 
    ( 
     id_curriculo
    ) 
    NOT DEFERRABLE 
;


ALTER TABLE ADMIN_BBDD.Direccion 
    ADD CONSTRAINT ciudad FOREIGN KEY 
    ( 
     cp
    ) 
    REFERENCES ADMIN_BBDD.Poblacion 
    ( 
     cp
    ) 
    ON DELETE CASCADE 
    NOT DEFERRABLE 
;


ALTER TABLE ADMIN_BBDD.Empresa 
    ADD CONSTRAINT contacto FOREIGN KEY 
    ( 
     id_persona
    ) 
    REFERENCES ADMIN_BBDD.Persona 
    ( 
     id_persona
    ) 
    NOT DEFERRABLE 
;


ALTER TABLE ADMIN_BBDD.Empresa 
    ADD CONSTRAINT "domicilio fiscal" FOREIGN KEY 
    ( 
     id_direccion
    ) 
    REFERENCES ADMIN_BBDD.Direccion 
    ( 
     id_direccion
    ) 
    NOT DEFERRABLE 
;


ALTER TABLE ADMIN_BBDD.Trabajador 
    ADD CONSTRAINT es FOREIGN KEY 
    ( 
     id_persona
    ) 
    REFERENCES ADMIN_BBDD.Persona 
    ( 
     id_persona
    ) 
    NOT DEFERRABLE 
;


ALTER TABLE ADMIN_BBDD.Oferta 
    ADD CONSTRAINT "es de la empresa" FOREIGN KEY 
    ( 
     id_empresa
    ) 
    REFERENCES ADMIN_BBDD.Empresa 
    ( 
     id_empresa
    ) 
    NOT DEFERRABLE 
;


ALTER TABLE ADMIN_BBDD.Direccion 
    ADD CONSTRAINT "es de tipo" FOREIGN KEY 
    ( 
     id_tipo
    ) 
    REFERENCES ADMIN_BBDD.Tipo_via 
    ( 
     id_tipo
    ) 
    NOT DEFERRABLE 
;


ALTER TABLE ADMIN_BBDD.Idioma 
    ADD CONSTRAINT "es idioma" FOREIGN KEY 
    ( 
     id_idiomas
    ) 
    REFERENCES ADMIN_BBDD.Idiomas 
    ( 
     id_idiomas
    ) 
    NOT DEFERRABLE 
;


ALTER TABLE ADMIN_BBDD.Entrevista 
    ADD CONSTRAINT "es para" FOREIGN KEY 
    ( 
     id_oferta
    ) 
    REFERENCES ADMIN_BBDD.Oferta 
    ( 
     id_oferta
    ) 
    NOT DEFERRABLE 
;


ALTER TABLE ADMIN_BBDD.Experiencia 
    ADD CONSTRAINT "experiencia en" FOREIGN KEY 
    ( 
     id_puesto
    ) 
    REFERENCES ADMIN_BBDD.Puesto 
    ( 
     id_puesto
    ) 
    NOT DEFERRABLE 
;


ALTER TABLE ADMIN_BBDD.Idioma 
    ADD CONSTRAINT "idiomas que domina" FOREIGN KEY 
    ( 
     id_curriculo
    ) 
    REFERENCES ADMIN_BBDD.Curriculo 
    ( 
     id_curriculo
    ) 
    NOT DEFERRABLE 
;


ALTER TABLE ADMIN_BBDD.Poblacion 
    ADD CONSTRAINT pais FOREIGN KEY 
    ( 
     id_pais
    ) 
    REFERENCES ADMIN_BBDD.Pais 
    ( 
     id_pais
    ) 
    NOT DEFERRABLE 
;


ALTER TABLE ADMIN_BBDD.Experiencia 
    ADD CONSTRAINT "pertenece a" FOREIGN KEY 
    ( 
     id_oferta
    ) 
    REFERENCES ADMIN_BBDD.Oferta 
    ( 
     id_oferta
    ) 
    NOT DEFERRABLE 
;


ALTER TABLE ADMIN_BBDD.Puesto 
    ADD CONSTRAINT "pertenece a" FOREIGN KEY 
    ( 
     id_tipo
    ) 
    REFERENCES ADMIN_BBDD.Tipo_puesto 
    ( 
     id_tipo
    ) 
    NOT DEFERRABLE 
;


ALTER TABLE ADMIN_BBDD.Empleo 
    ADD CONSTRAINT "puesto ocupado" FOREIGN KEY 
    ( 
     id_puesto
    ) 
    REFERENCES ADMIN_BBDD.Puesto 
    ( 
     id_puesto
    ) 
    NOT DEFERRABLE 
;


ALTER TABLE ADMIN_BBDD.Oferta 
    ADD CONSTRAINT "puesto ofertado" FOREIGN KEY 
    ( 
     id_puesto
    ) 
    REFERENCES ADMIN_BBDD.Puesto 
    ( 
     id_puesto
    ) 
    NOT DEFERRABLE 
;


ALTER TABLE ADMIN_BBDD.Entrevista 
    ADD CONSTRAINT realiza FOREIGN KEY 
    ( 
     id_trabajador
    ) 
    REFERENCES ADMIN_BBDD.Trabajador 
    ( 
     id_trabajador
    ) 
    NOT DEFERRABLE 
;


ALTER TABLE ADMIN_BBDD.Curriculo 
    ADD CONSTRAINT tiene FOREIGN KEY 
    ( 
     id_trabajador
    ) 
    REFERENCES ADMIN_BBDD.Trabajador 
    ( 
     id_trabajador
    ) 
    ON DELETE CASCADE 
    NOT DEFERRABLE 
;


ALTER TABLE ADMIN_BBDD.Persona 
    ADD CONSTRAINT "vive en" FOREIGN KEY 
    ( 
     id_direccion
    ) 
    REFERENCES ADMIN_BBDD.Direccion 
    ( 
     id_direccion
    ) 
    NOT DEFERRABLE 
;
