DROP TABLE ADMIN_BBDD.Dim_Empresa CASCADE CONSTRAINTS 
;
DROP TABLE ADMIN_BBDD.Dim_Experiencia CASCADE CONSTRAINTS 
;
DROP TABLE ADMIN_BBDD.Dim_Puesto CASCADE CONSTRAINTS 
;
DROP TABLE ADMIN_BBDD.Dim_Tipo_Puesto CASCADE CONSTRAINTS 
;
DROP TABLE ADMIN_BBDD.Hecho_Oferta CASCADE CONSTRAINTS 
;

CREATE TABLE ADMIN_BBDD.Dim_Empresa 
    ( 
     id_empresa NUMBER  NOT NULL , 
     cif VARCHAR2 (15)  NOT NULL , 
     nombre VARCHAR2 (30)  NOT NULL , 
     email VARCHAR2 (30) , 
     telefono NUMBER  NOT NULL 
    ) 
;
ALTER TABLE ADMIN_BBDD.Dim_Empresa 
    ADD CONSTRAINT "Empresa PK" PRIMARY KEY ( id_empresa ) ;
	


CREATE TABLE ADMIN_BBDD.Dim_Experiencia 
    ( 
     id_Experiencia NUMBER  NOT NULL , 
     id_oferta NUMBER  NOT NULL , 
     id_puesto NUMBER  NOT NULL 
    ) 
;


CREATE UNIQUE INDEX Experiencia__IDXv1 ON ADMIN_BBDD.Dim_Experiencia 
    ( 
     id_puesto ASC 
    ) 
;
CREATE UNIQUE INDEX Experiencia__IDXv2 ON ADMIN_BBDD.Dim_Experiencia 
    ( 
     id_oferta ASC 
    ) 
;

ALTER TABLE ADMIN_BBDD.Dim_Experiencia 
    ADD CONSTRAINT "Experiencia PK" PRIMARY KEY ( id_Experiencia ) ;



CREATE TABLE ADMIN_BBDD.Dim_Puesto 
    ( 
     id_puesto NUMBER  NOT NULL , 
     descripcion VARCHAR2 (30)  NOT NULL , 
     id_tipo NUMBER  NOT NULL 
    ) 
;



ALTER TABLE ADMIN_BBDD.Dim_Puesto 
    ADD CONSTRAINT "Puesto PK" PRIMARY KEY ( id_puesto ) ;



CREATE TABLE ADMIN_BBDD.Dim_Tipo_puesto 
    ( 
     id_tipo NUMBER  NOT NULL , 
     descripcion VARCHAR2 (30)  NOT NULL 
    ) 
;



ALTER TABLE ADMIN_BBDD.Dim_Tipo_puesto 
    ADD CONSTRAINT "Tipo_puesto PK" PRIMARY KEY ( id_tipo ) ;



CREATE TABLE ADMIN_BBDD.Hecho_Oferta 
    ( 
     id_oferta NUMBER  NOT NULL , 
     remuneracion NUMBER  NOT NULL , 
     prioridad NUMBER  NOT NULL , 
     fecha_inicio DATE  NOT NULL , 
     fecha_adjudicacion DATE , 
     id_puesto NUMBER  NOT NULL , 
     id_empresa NUMBER  NOT NULL 
    ) 
;


CREATE UNIQUE INDEX Oferta__IDXv1 ON ADMIN_BBDD.Hecho_Oferta 
    ( 
     id_puesto ASC 
    ) 
;

ALTER TABLE ADMIN_BBDD.Hecho_Oferta 
    ADD CONSTRAINT "Oferta PK" PRIMARY KEY ( id_oferta ) ;




ALTER TABLE ADMIN_BBDD.Hecho_Oferta 
    ADD CONSTRAINT "es de la empresa" FOREIGN KEY 
    ( 
     id_empresa
    ) 
    REFERENCES Dim_Empresa 
    ( 
     id_empresa
    ) 
;


ALTER TABLE ADMIN_BBDD.Dim_Experiencia 
    ADD CONSTRAINT "experiencia en" FOREIGN KEY 
    ( 
     id_puesto
    ) 
    REFERENCES Dim_Puesto 
    ( 
     id_puesto
    ) 
;


ALTER TABLE ADMIN_BBDD.Dim_Experiencia 
    ADD CONSTRAINT "pertenece a" FOREIGN KEY 
    ( 
     id_oferta
    ) 
    REFERENCES Hecho_Oferta 
    ( 
     id_oferta
    ) 
;


ALTER TABLE ADMIN_BBDD.Dim_Puesto 
    ADD CONSTRAINT "pertenece a" FOREIGN KEY 
    ( 
     id_tipo
    ) 
    REFERENCES Dim_Tipo_puesto 
    ( 
     id_tipo
    ) 
;


ALTER TABLE ADMIN_BBDD.Hecho_Oferta 
    ADD CONSTRAINT "puesto ofertado" FOREIGN KEY 
    ( 
     id_puesto
    ) 
    REFERENCES Dim_Puesto 
    ( 
     id_puesto
    ) 
;
