-- ************************************************************
-- PROCEDIMIENTO DE ELIMINACIN DE REGISTROS DE CUALQUIER TABLA
create or replace
PROCEDURE ADMIN_BBDD.ELIMINAR_REGISTRO(
    id_registro  NUMBER,
    nombre_tabla VARCHAR)
IS
nombre_clave VARCHAR(30);
sentencia VARCHAR(50);
BEGIN
   nombre_clave := "ADMIN_BBDD"."OBTENER_NOMBRE_CLAVE" (nombre_tabla);
   sentencia := 'DELETE FROM ADMIN_BBDD."'||nombre_tabla||'" WHERE '||nombre_clave||' = '||id_registro;
   DBMS_OUTPUT.put_line ('La sentencia es: '||sentencia);
   EXECUTE IMMEDIATE sentencia;
   EXCEPTION WHEN OTHERS THEN raise_application_error (-20001, SQLERRM);
END "ELIMINAR_REGISTRO";
/
GRANT ALL PRIVILEGES
ON ADMIN_BBDD.ELIMINAR_REGISTRO TO ADMIN_BBDD
;
GRANT EXECUTE
ON ADMIN_BBDD.ELIMINAR_REGISTRO TO USUARIO_BBDD
;



--*************************************
-- PROCEDIMIENTO DE INSERCIN DE PAISES
create or replace
PROCEDURE ADMIN_BBDD.INSERTAR_PAIS(
    descripcion VARCHAR)
IS
BEGIN
  INSERT
  INTO "PAIS"
    (
		"ID_PAIS",
      "NOMBRE"
    )
    VALUES
    (
      SECUENCIA_ID_PAIS.NEXTVAL,
      descripcion
    );
EXCEPTION
WHEN OTHERS THEN
  raise_application_error (-20001, SQLERRM);
END "INSERTAR_PAIS";
/
GRANT ALL PRIVILEGES
ON ADMIN_BBDD.INSERTAR_PAIS TO admin_BBDD
;
GRANT EXECUTE
ON ADMIN_BBDD.INSERTAR_PAIS TO usuario_BBDD
;
--*****************************************
-- PROCEDIMEINTO DE CONSULTA DE PAS POR ID
create or replace
PROCEDURE ADMIN_BBDD.CONSULTAR_PAIS(
    id NUMBER,
	registro OUT "PAIS"%ROWTYPE)
IS
BEGIN
  SELECT * INTO registro
  FROM "PAIS"
    WHERE id_pais = id;
EXCEPTION
WHEN OTHERS THEN
  raise_application_error (-20001, SQLERRM);
END "CONSULTAR_PAIS";
/
GRANT ALL PRIVILEGES
ON ADMIN_BBDD.CONSULTAR_PAIS TO admin_BBDD
;
GRANT EXECUTE
ON ADMIN_BBDD.CONSULTAR_PAIS TO usuario_BBDD
;


--******************************************
-- PROCEDIMIENTO DE INSERCIN DE POBLACIONES
create or replace
PROCEDURE ADMIN_BBDD.INSERTAR_POBLACION(
	cp NUMBER,
    descripcion VARCHAR,
	id_pais NUMBER)
IS
BEGIN
  INSERT
  INTO "POBLACION"
    (
		"CP",
      "NOMBRE",
	  "ID_PAIS"
    )
    VALUES
    (
      cp,
      descripcion,
	  id_pais
    );
EXCEPTION
WHEN OTHERS THEN
  raise_application_error (-20001, SQLERRM);
END "INSERTAR_POBLACION";
/
GRANT ALL PRIVILEGES
ON ADMIN_BBDD.INSERTAR_POBLACION TO admin_BBDD
;
GRANT EXECUTE
ON ADMIN_BBDD.INSERTAR_POBLACION TO usuario_BBDD
;

--*****************************************
-- PROCEDIMIENTO DE CONSULTA DE POBLACION POR ID
create or replace
PROCEDURE ADMIN_BBDD.CONSULTAR_POBLACION(
    id NUMBER,
	registro OUT "POBLACION"%ROWTYPE)
IS
BEGIN
  SELECT * INTO registro
  FROM "POBLACION"
    WHERE cp = id;
EXCEPTION
WHEN OTHERS THEN
  raise_application_error (-20001, SQLERRM);
END "CONSULTAR_POBLACION";
/
GRANT ALL PRIVILEGES
ON ADMIN_BBDD.CONSULTAR_POBLACION TO admin_BBDD
;
GRANT EXECUTE
ON ADMIN_BBDD.CONSULTAR_POBLACION TO usuario_BBDD
;

--******************************************
-- PROCEDIMIENTO DE INSERCIN DE IDIOMA
create or replace
PROCEDURE ADMIN_BBDD.INSERTAR_IDIOMA(
    nivel VARCHAR,
	id_idiomas NUMBER,
	id_curriculo NUMBER)
IS
BEGIN
  INSERT
  INTO "IDIOMA"
    (
		"ID_IDIOMA",
      "NIVEL",
	  "ID_IDIOMAS",
	  "ID_CURRICULO"
    )
    VALUES
    (
      SECUENCIA_ID_IDIOMA.NEXTVAL,
	  nivel,
      id_idiomas,
	  id_curriculo
    );
EXCEPTION
WHEN OTHERS THEN
  raise_application_error (-20001, SQLERRM);
END "INSERTAR_IDIOMA";
/
GRANT ALL PRIVILEGES
ON ADMIN_BBDD.INSERTAR_IDIOMA TO admin_BBDD
;
GRANT EXECUTE
ON ADMIN_BBDD.INSERTAR_IDIOMA TO usuario_BBDD
;

--*****************************************
-- PROCEDIMIENTO DE CONSULTA DE IDIOMA POR ID
create or replace
PROCEDURE ADMIN_BBDD.CONSULTAR_IDIOMA(
    id NUMBER,
	registro OUT "IDIOMA"%ROWTYPE)
IS
BEGIN
  SELECT * INTO registro
  FROM "IDIOMA"
    WHERE id_idioma = id;
EXCEPTION
WHEN OTHERS THEN
  raise_application_error (-20001, SQLERRM);
END "CONSULTAR_IDIOMA";
/
GRANT ALL PRIVILEGES
ON ADMIN_BBDD.CONSULTAR_IDIOMA TO admin_BBDD
;
GRANT EXECUTE
ON ADMIN_BBDD.CONSULTAR_IDIOMA TO usuario_BBDD
;



--******************************************
-- PROCEDIMIENTO DE INSERCIN DE IDIOMAS
create or replace
PROCEDURE ADMIN_BBDD.INSERTAR_IDIOMAS(
    descripcion VARCHAR)
IS
BEGIN
  INSERT
  INTO "IDIOMAS"
    (
	  "ID_IDIOMAS",
	  "DESCRIPCION"
    )
    VALUES
    (
      SECUENCIA_ID_IDIOMAS.NEXTVAL,
	  descripcion
    );
EXCEPTION
WHEN OTHERS THEN
  raise_application_error (-20001, SQLERRM);
END "INSERTAR_IDIOMAS";
/
GRANT ALL PRIVILEGES
ON ADMIN_BBDD.INSERTAR_IDIOMAS TO admin_BBDD
;
GRANT EXECUTE
ON ADMIN_BBDD.INSERTAR_IDIOMAS TO usuario_BBDD
;

--*****************************************
-- PROCEDIMIENTO DE CONSULTA DE IDIOMAS POR ID
create or replace
PROCEDURE ADMIN_BBDD.CONSULTAR_IDIOMAS(
    id NUMBER,
	registro OUT "IDIOMAS"%ROWTYPE)
IS
BEGIN
  SELECT * INTO registro
  FROM "IDIOMAS"
    WHERE id_idiomas = id;
EXCEPTION
WHEN OTHERS THEN
  raise_application_error (-20001, SQLERRM);
END "CONSULTAR_IDIOMAS";
/
GRANT ALL PRIVILEGES
ON ADMIN_BBDD.CONSULTAR_IDIOMAS TO admin_BBDD
;
GRANT EXECUTE
ON ADMIN_BBDD.CONSULTAR_IDIOMAS TO usuario_BBDD
;



--***************************************************
-- PROCEDIMIENTO DE INSERCIN DE TIPOS DE DIRECCIONES
create or replace
PROCEDURE ADMIN_BBDD.INSERTAR_TIPO_VIA(
    id_tipo NUMBER,
    descripcion VARCHAR)
IS
BEGIN
  INSERT
  INTO "TIPO_VIA"
    (
      "ID_TIPO",
      "DESCRIPCION"
    )
    VALUES
    (
      SECUENCIA_ID_TIPO_VIA.NEXTVAL,
      descripcion
    );
EXCEPTION
WHEN OTHERS THEN
  raise_application_error (-20001, SQLERRM);
END "INSERTAR_TIPO_VIA";
/
GRANT ALL PRIVILEGES
ON ADMIN_BBDD.INSERTAR_TIPO_VIA TO admin_BBDD
;
GRANT EXECUTE
ON ADMIN_BBDD.INSERTAR_TIPO_VIA TO usuario_BBDD
;


--*****************************************
-- PROCEDIMIENTO DE CONSULTA DE TIPO DE VIA POR ID
create or replace
PROCEDURE ADMIN_BBDD.CONSULTAR_TIPO_VIA(
    id NUMBER,
	registro OUT "TIPO_VIA"%ROWTYPE)
IS
BEGIN
  SELECT * INTO registro
  FROM "TIPO_VIA"
    WHERE id_tipo = id;
EXCEPTION
WHEN OTHERS THEN
  raise_application_error (-20001, SQLERRM);
END "CONSULTAR_TIPO_VIA";
/
GRANT ALL PRIVILEGES
ON ADMIN_BBDD.CONSULTAR_TIPO_VIA TO admin_BBDD
;
GRANT EXECUTE
ON ADMIN_BBDD.CONSULTAR_TIPO_VIA TO usuario_BBDD
;

-- ****************************************
-- PROCEDIMIENTO DE INSERCIN DE CURRCULOS
create or replace
PROCEDURE ADMIN_BBDD.INSERTAR_CURRICULO(
    id_trabajador NUMBER,
    fecha          DATE,
    foto   BLOB)
IS
BEGIN
  INSERT
  INTO "CURRICULO"
    (
      "ID_CURRICULO",
      "ID_TRABAJADOR",
      "FECHA",
      "FOTO"
    )
    VALUES
    (
      SECUENCIA_ID_CURRICULO.NEXTVAL,
      id_trabajador,
      fecha,
      foto
    );
EXCEPTION
WHEN OTHERS THEN
  raise_application_error (-20001, SQLERRM);
END "INSERTAR_CURRICULO";
/
GRANT ALL PRIVILEGES
ON ADMIN_BBDD.INSERTAR_CURRICULO TO admin_BBDD
;
GRANT EXECUTE
ON ADMIN_BBDD.INSERTAR_CURRICULO TO usuario_BBDD
;


--*****************************************
-- PROCEDIMIENTO DE CONSULTA DE CURRICULOS POR ID
create or replace
PROCEDURE ADMIN_BBDD.CONSULTAR_CURRICULO(
    id NUMBER,
	registro OUT "CURRICULO"%ROWTYPE)
IS
BEGIN
  SELECT * INTO registro
  FROM "CURRICULO"
    WHERE id_curriculo = id;
EXCEPTION
WHEN OTHERS THEN
  raise_application_error (-20001, SQLERRM);
END "CONSULTAR_CURRICULO";
/
GRANT ALL PRIVILEGES
ON ADMIN_BBDD.CONSULTAR_CURRICULO TO admin_BBDD
;
GRANT EXECUTE
ON ADMIN_BBDD.CONSULTAR_CURRICULO TO usuario_BBDD
;


--******************************************
-- PROCEDIMIENTO DE INSERCIN DE PUESTO
create or replace
PROCEDURE ADMIN_BBDD.INSERTAR_PUESTO(
    descripcion VARCHAR,
	id_tipo NUMBER)
IS
BEGIN
  INSERT
  INTO "PUESTO"
    (
	  "ID_PUESTO",
      "DESCRIPCION",
	  "ID_TIPO"
    )
    VALUES
    (
      SECUENCIA_ID_PUESTO.NEXTVAL,
	  descripcion,
      id_tipo
    );
EXCEPTION
WHEN OTHERS THEN
  raise_application_error (-20001, SQLERRM);
END "INSERTAR_PUESTO";
/
GRANT ALL PRIVILEGES
ON ADMIN_BBDD.INSERTAR_PUESTO TO admin_BBDD
;
GRANT EXECUTE
ON ADMIN_BBDD.INSERTAR_PUESTO TO usuario_BBDD
;

--*****************************************
-- PROCEDIMIENTO DE CONSULTA DE PUESTO POR ID
create or replace
PROCEDURE ADMIN_BBDD.CONSULTAR_PUESTO(
    id NUMBER,
	registro OUT "PUESTO"%ROWTYPE)
IS
BEGIN
  SELECT * INTO registro
  FROM "PUESTO"
    WHERE id_PUESTO = id;
EXCEPTION
WHEN OTHERS THEN
  raise_application_error (-20001, SQLERRM);
END "CONSULTAR_PUESTO";
/
GRANT ALL PRIVILEGES
ON ADMIN_BBDD.CONSULTAR_PUESTO TO admin_BBDD
;
GRANT EXECUTE
ON ADMIN_BBDD.CONSULTAR_PUESTO TO usuario_BBDD
;



--******************************************
-- PROCEDIMIENTO DE INSERCIN DE TIPO DE PUESTO
create or replace
PROCEDURE ADMIN_BBDD.INSERTAR_TIPO_PUESTO(
    descripcion VARCHAR)
IS
BEGIN
  INSERT
  INTO "TIPO_PUESTO"
    (
	  "ID_TIPO",
	  "DESCRIPCION"
    )
    VALUES
    (
      SECUENCIA_ID_TIPO_PUESTO.NEXTVAL,
	  descripcion
    );
EXCEPTION
WHEN OTHERS THEN
  raise_application_error (-20001, SQLERRM);
END "INSERTAR_TIPO_PUESTO";
/
GRANT ALL PRIVILEGES
ON ADMIN_BBDD.INSERTAR_TIPO_PUESTO TO admin_BBDD
;
GRANT EXECUTE
ON ADMIN_BBDD.INSERTAR_TIPO_PUESTO TO usuario_BBDD
;

--*****************************************
-- PROCEDIMIENTO DE CONSULTA DE TIPO DE PUESTO POR ID
create or replace
PROCEDURE ADMIN_BBDD.CONSULTAR_TIPO_PUESTO(
    id NUMBER,
	registro OUT "TIPO_PUESTO"%ROWTYPE)
IS
BEGIN
  SELECT * INTO registro
  FROM "TIPO_PUESTO"
    WHERE id_tipo = id;
EXCEPTION
WHEN OTHERS THEN
  raise_application_error (-20001, SQLERRM);
END "CONSULTAR_TIPO_PUESTO";
/
GRANT ALL PRIVILEGES
ON ADMIN_BBDD.CONSULTAR_TIPO_PUESTO TO admin_BBDD
;
GRANT EXECUTE
ON ADMIN_BBDD.CONSULTAR_TIPO_PUESTO TO usuario_BBDD
;



-- ****************************************
-- PROCEDIMIENTO DE INSERCIN DE EMPLEOS
create or replace
PROCEDURE ADMIN_BBDD.INSERTAR_EMPLEO(
    nom_empresa VARCHAR,
	fecha_inicio DATE,
	fecha_fin DATE,
	id_puesto NUMBER,
	id_curriculo NUMBER)
IS
BEGIN
  INSERT
  INTO "EMPLEO"
    (
      "ID_EMPLEO",
	  "NOM_EMPRESA",
	  "FECHA_INICIO",
	  "FECHA_FIN",
      "ID_PUESTO",
      "ID_CURRICULO"
    )
    VALUES
    (
      SECUENCIA_ID_EMPLEO.NEXTVAL,
      nom_empresa,
	  fecha_inicio,
	  fecha_fin,
	  id_puesto,
      id_curriculo
    );
EXCEPTION
WHEN OTHERS THEN
  raise_application_error (-20001, SQLERRM);
END "INSERTAR_EMPLEO";
/
GRANT ALL PRIVILEGES
ON ADMIN_BBDD.INSERTAR_EMPLEO TO admin_BBDD
;
GRANT EXECUTE
ON ADMIN_BBDD.INSERTAR_EMPLEO TO usuario_BBDD
;


--*****************************************
-- PROCEDIMIENTO DE CONSULTA DE EMPLEOS POR ID
create or replace
PROCEDURE ADMIN_BBDD.CONSULTAR_EMPLEO(
    id NUMBER,
	registro OUT "EMPLEO"%ROWTYPE)
IS
BEGIN
  SELECT * INTO registro
  FROM "EMPLEO"
    WHERE id_empleo = id;
EXCEPTION
WHEN OTHERS THEN
  raise_application_error (-20001, SQLERRM);
END "CONSULTAR_EMPLEO";
/
GRANT ALL PRIVILEGES
ON ADMIN_BBDD.CONSULTAR_EMPLEO TO admin_BBDD
;
GRANT EXECUTE
ON ADMIN_BBDD.CONSULTAR_EMPLEO TO usuario_BBDD
;

-- ****************************************
-- PROCEDIMIENTO DE INSERCIN DE EMPRESAS
create or replace
PROCEDURE ADMIN_BBDD.INSERTAR_EMPRESA(
    cif VARCHAR,
	nombre VARCHAR,
	email VARCHAR,
	telefono NUMBER,
	id_direccion NUMBER,
	id_persona NUMBER)
IS
BEGIN
  INSERT
  INTO "EMPRESA"
    (
      "ID_EMPRESA",
	  "CIF",
	  "NOMBRE",
	  "EMAIL",
	  "TELEFONO",
      "ID_DIRECCION",
      "ID_PERSONA"
    )
    VALUES
    (
      SECUENCIA_ID_EMPRESA.NEXTVAL,
      cif,
	  nombre,
	  email,
	  telefono,
	  id_direccion,
      id_persona
    );
EXCEPTION
WHEN OTHERS THEN
  raise_application_error (-20001, SQLERRM);
END "INSERTAR_EMPRESA";
/
GRANT ALL PRIVILEGES
ON ADMIN_BBDD.INSERTAR_EMPRESA TO admin_BBDD
;
GRANT EXECUTE
ON ADMIN_BBDD.INSERTAR_EMPRESA TO usuario_BBDD
;


--*****************************************
-- PROCEDIMIENTO DE CONSULTA DE EMPRESAS POR ID
create or replace
PROCEDURE ADMIN_BBDD.CONSULTAR_EMPRESA(
    id NUMBER,
	registro OUT "EMPRESA"%ROWTYPE)
IS
BEGIN
  SELECT * INTO registro
  FROM "EMPRESA"
    WHERE id_empresa = id;
EXCEPTION
WHEN OTHERS THEN
  raise_application_error (-20001, SQLERRM);
END "CONSULTAR_EMPRESA";
/
GRANT ALL PRIVILEGES
ON ADMIN_BBDD.CONSULTAR_EMPRESA TO admin_BBDD
;
GRANT EXECUTE
ON ADMIN_BBDD.CONSULTAR_EMPRESA TO usuario_BBDD
;



-- ****************************************
-- PROCEDIMIENTO DE INSERCIN DE OFERTAS
create or replace
PROCEDURE ADMIN_BBDD.INSERTAR_OFERTA(
    remuneracion NUMBER,
	prioridad NUMBER,
	fecha_inicio DATE,
	fecha_adjudicacion DATE,
	id_puesto NUMBER,
	id_empresa NUMBER)
IS
BEGIN
  INSERT
  INTO "OFERTA"
    (
      "ID_OFERTA",
	  "REMUNERACION",
	  "PRIORIDAD",
	  "FECHA_INICIO",
	  "FECHA_ADJUDICACION",
      "ID_PUESTO",
      "ID_EMPRESA"
    )
    VALUES
    (
      SECUENCIA_ID_OFERTA.NEXTVAL,
      remuneracion,
	  prioridad,
	  fecha_inicio,
	  fecha_adjudicacion,
	  id_puesto,
      id_empresa
    );
EXCEPTION
WHEN OTHERS THEN
  raise_application_error (-20001, SQLERRM);
END "INSERTAR_OFERTA";
/
GRANT ALL PRIVILEGES
ON ADMIN_BBDD.INSERTAR_OFERTA TO admin_BBDD
;
GRANT EXECUTE
ON ADMIN_BBDD.INSERTAR_OFERTA TO usuario_BBDD
;


--*****************************************
-- PROCEDIMIENTO DE CONSULTA DE OFERTAS POR ID
create or replace
PROCEDURE ADMIN_BBDD.CONSULTAR_OFERTA(
    id NUMBER,
	registro OUT "OFERTA"%ROWTYPE)
IS
BEGIN
  SELECT * INTO registro
  FROM "OFERTA"
    WHERE id_OFERTA = id;
EXCEPTION
WHEN OTHERS THEN
  raise_application_error (-20001, SQLERRM);
END "CONSULTAR_OFERTA";
/
GRANT ALL PRIVILEGES
ON ADMIN_BBDD.CONSULTAR_OFERTA TO admin_BBDD
;
GRANT EXECUTE
ON ADMIN_BBDD.CONSULTAR_OFERTA TO usuario_BBDD
;



-- ****************************************
-- PROCEDIMIENTO DE INSERCIN DE ENTREVISTAS
create or replace
PROCEDURE ADMIN_BBDD.INSERTAR_ENTREVISTA(
    fecha DATE,
	id_oferta NUMBER,
	id_trabajador NUMBER)
IS
BEGIN
  INSERT
  INTO "ENTREVISTA"
    (
      "ID_ENTREVISTA",
	  "FECHA",
      "ID_OFERTA",
      "ID_TRABAJADOR"
    )
    VALUES
    (
      SECUENCIA_ID_ENTREVISTA.NEXTVAL,
	  fecha,
	  id_oferta,
      id_trabajador
    );
EXCEPTION
WHEN OTHERS THEN
  raise_application_error (-20001, SQLERRM);
END "INSERTAR_ENTREVISTA";
/
GRANT ALL PRIVILEGES
ON ADMIN_BBDD.INSERTAR_ENTREVISTA TO admin_BBDD
;
GRANT EXECUTE
ON ADMIN_BBDD.INSERTAR_ENTREVISTA TO usuario_BBDD
;

--*****************************************
-- PROCEDIMIENTO DE CONSULTA DE ENTREVISTAS POR ID
create or replace
PROCEDURE ADMIN_BBDD.CONSULTAR_ENTREVISTA(
    id NUMBER,
	registro OUT "ENTREVISTA"%ROWTYPE)
IS
BEGIN
  SELECT * INTO registro
  FROM "ENTREVISTA"
    WHERE id_ENTREVISTA = id;
EXCEPTION
WHEN OTHERS THEN
  raise_application_error (-20001, SQLERRM);
END "CONSULTAR_ENTREVISTA";
/
GRANT ALL PRIVILEGES
ON ADMIN_BBDD.CONSULTAR_ENTREVISTA TO admin_BBDD
;
GRANT EXECUTE
ON ADMIN_BBDD.CONSULTAR_ENTREVISTA TO usuario_BBDD
;


-- ****************************************
-- PROCEDIMIENTO DE INSERCIN DE EXPERIENCIAS
create or replace
PROCEDURE ADMIN_BBDD.INSERTAR_EXPERIENCIA(
	id_oferta NUMBER,
	id_puesto NUMBER)
IS
BEGIN
  INSERT
  INTO "EXPERIENCIA"
    (
      "ID_EXPERIENCIA",
      "ID_OFERTA",
      "ID_PUESTO"
    )
    VALUES
    (
      SECUENCIA_ID_EXPERIENCIA.NEXTVAL,
	  id_oferta,
      id_puesto
    );
EXCEPTION
WHEN OTHERS THEN
  raise_application_error (-20001, SQLERRM);
END "INSERTAR_EXPERIENCIA";
/
GRANT ALL PRIVILEGES
ON ADMIN_BBDD.INSERTAR_EXPERIENCIA TO admin_BBDD
;
GRANT EXECUTE
ON ADMIN_BBDD.INSERTAR_EXPERIENCIA TO usuario_BBDD
;

--*****************************************
-- PROCEDIMIENTO DE CONSULTA DE EXPERIENCIAS POR ID
create or replace
PROCEDURE ADMIN_BBDD.CONSULTAR_EXPERIENCIA(
    id NUMBER,
	registro OUT "EXPERIENCIA"%ROWTYPE)
IS
BEGIN
  SELECT * INTO registro
  FROM "EXPERIENCIA"
    WHERE id_experiencia = id;
EXCEPTION
WHEN OTHERS THEN
  raise_application_error (-20001, SQLERRM);
END "CONSULTAR_EXPERIENCIA";
/
GRANT ALL PRIVILEGES
ON ADMIN_BBDD.CONSULTAR_EXPERIENCIA TO admin_BBDD
;
GRANT EXECUTE
ON ADMIN_BBDD.CONSULTAR_EXPERIENCIA TO usuario_BBDD
;


-- *****************************************
-- PROCEDIMIENTO DE INSERCIN DE DIRECCIONES
create or replace
PROCEDURE ADMIN_BBDD.INSERTAR_DIRECCION(
    tipo   NUMBER,
    nombre VARCHAR,
    numero NUMBER,
    piso   NUMBER,
    puerta VARCHAR,
    cp     NUMBER)
IS
BEGIN
  INSERT
  INTO "DIRECCION"
    (
      "ID_DIRECCION",
      "ID_TIPO",
      "NOMBRE",
      "NUMERO",
      "PISO",
      "PUERTA",
      "CP"
    )
    VALUES
    (
      SECUENCIA_ID_DIRECCION.NEXTVAL,
      tipo,
      nombre,
      numero,
      piso,
      puerta,
      cp
    );
EXCEPTION
WHEN OTHERS THEN
  raise_application_error (-20001, SQLERRM);
END "INSERTAR_DIRECCION";
/
GRANT ALL PRIVILEGES
ON ADMIN_BBDD.INSERTAR_DIRECCION TO admin_BBDD 
;
GRANT EXECUTE
ON ADMIN_BBDD.INSERTAR_DIRECCION TO usuario_BBDD
;

--*****************************************
-- PROCEDIMIENTO DE CONSULTA DE DIRECCIN POR ID
create or replace
PROCEDURE ADMIN_BBDD.CONSULTAR_DIRECCION(
    id NUMBER,
	registro OUT "DIRECCION"%ROWTYPE)
IS
BEGIN
  SELECT * INTO registro
  FROM "DIRECCION"
    WHERE id_direccion = id;
EXCEPTION
WHEN OTHERS THEN
  raise_application_error (-20001, SQLERRM);
END "CONSULTAR_DIRECCION";
/
GRANT ALL PRIVILEGES
ON ADMIN_BBDD.CONSULTAR_DIRECCION TO admin_BBDD
;
GRANT EXECUTE
ON ADMIN_BBDD.CONSULTAR_DIRECCION TO usuario_BBDD
;

-- *****************************************
-- PROCEDIMIENTO DE INSERCIN DE PERSONAS
create or replace
PROCEDURE ADMIN_BBDD.INSERTAR_PERSONA(
    nif       CHAR,
    nombre    CHAR,
    apellido1 CHAR,
    apellido2 CHAR,
    email     CHAR,
    telefono  NUMBER,
    direccion NUMBER)
IS
BEGIN
  INSERT
  INTO "PERSONA"
    (
      "ID_PERSONA",
      "NIF",
      "NOMBRE",
      "APELLIDO_1",
      "APELLIDO_2",
      "EMAIL",
      "TELEFONO",
      "ID_DIRECCION"
    )
    VALUES
    (
      SECUENCIA_ID_PERSONA.NEXTVAL,
      nif,
      nombre,
      apellido1,
      apellido2,
      email,
      telefono,
      direccion
    );
EXCEPTION
WHEN OTHERS THEN
  raise_application_error (-20001, SQLERRM);
END "INSERTAR_PERSONA";
/
GRANT ALL PRIVILEGES
ON ADMIN_BBDD.INSERTAR_PERSONA TO admin_BBDD
;
GRANT EXECUTE
ON ADMIN_BBDD.INSERTAR_PERSONA TO usuario_BBDD
;

--*****************************************
-- PROCEDIMIENTO DE CONSULTA DE PERSONAS POR ID
create or replace
PROCEDURE ADMIN_BBDD.CONSULTAR_PERSONA(
    id NUMBER,
	registro OUT "PERSONA"%ROWTYPE)
IS
BEGIN
  SELECT * INTO registro
  FROM "PERSONA"
    WHERE id_persona = id;
EXCEPTION
WHEN OTHERS THEN
  raise_application_error (-20001, SQLERRM);
END "CONSULTAR_PERSONA";
/
GRANT ALL PRIVILEGES
ON ADMIN_BBDD.CONSULTAR_PERSONA TO admin_BBDD
;
GRANT EXECUTE
ON ADMIN_BBDD.CONSULTAR_PERSONA TO usuario_BBDD
;


-- *****************************************
-- PROCEDIMIENTO DE INSERCIN DE TRABAJADORES
CREATE OR REPLACE
PROCEDURE ADMIN_BBDD.INSERTAR_TRABAJADOR(
    nass          CHAR,
    id_persona    NUMERIC)
IS
BEGIN
  INSERT
  INTO "TRABAJADOR"
    (
      "ID_TRABAJADOR",
      "NASS",
      "ID_PERSONA"
    )
    VALUES
    (
      SECUENCIA_ID_TRABAJADOR.NEXTVAL,
      nass,
      id_persona
    );
EXCEPTION
WHEN OTHERS THEN
  raise_application_error (-20001, SQLERRM);
END "INSERTAR_TRABAJADOR";
/
GRANT ALL PRIVILEGES
ON ADMIN_BBDD.INSERTAR_TRABAJADOR TO admin_BBDD
;
GRANT EXECUTE
ON ADMIN_BBDD.INSERTAR_TRABAJADOR TO usuario_BBDD
;

--*****************************************
-- PROCEDIMIENTO DE CONSULTA DE TRABAJADORESS POR ID
create or replace
PROCEDURE ADMIN_BBDD.CONSULTAR_TRABAJADOR(
    id NUMBER,
	registro OUT "TRABAJADOR"%ROWTYPE)
IS
BEGIN
  SELECT * INTO registro
  FROM "TRABAJADOR"
    WHERE id_trabajador = id;
EXCEPTION
WHEN OTHERS THEN
  raise_application_error (-20001, SQLERRM);
END "CONSULTAR_TRABAJADOR";
/
GRANT ALL PRIVILEGES
ON ADMIN_BBDD.CONSULTAR_TRABAJADOR TO admin_BBDD
;
GRANT EXECUTE
ON ADMIN_BBDD.CONSULTAR_TRABAJADOR TO usuario_BBDD
;

-- ***********************************************************
-- FUNCIN PARA OBTENER EL NOMBRE DEL CAMPO CLAVE DE UNA TABLA
create or replace
FUNCTION ADMIN_BBDD.obtener_nombre_clave(
      nombre_tabla IN VARCHAR)
    RETURN VARCHAR
  AS
    nombre_clave VARCHAR(30);
  BEGIN
    SELECT cols.column_name
    INTO nombre_clave
    FROM user_constraints cons,
      user_cons_columns cols
    WHERE cons.constraint_type = 'P'
    AND cons.constraint_name   = cols.constraint_name
    AND cols.table_name LIKE (nombre_tabla);
    RETURN nombre_clave;
  END "OBTENER_NOMBRE_CLAVE";
/
GRANT ALL PRIVILEGES
ON ADMIN_BBDD.OBTENER_NOMBRE_CLAVE TO admin_BBDD
;
GRANT EXECUTE
ON ADMIN_BBDD.OBTENER_NOMBRE_CLAVE TO usuario_BBDD
;

-- ******************************************************************
-- PROCEDIMIENTO DE CONSULTA REGISTROS DE UNA TABLA CON UN VALOR DADO
create or replace
PROCEDURE ADMIN_BBDD.CONSULTAR_POR_CAMPO(
  tabla VARCHAR,
	campo VARCHAR,
	valor VARCHAR)
IS
  CURSOR cursor_registros_nombre IS SELECT * from "PAIS" WHERE "NOMBRE" like valor ;
  CURSOR cursor_registros_id IS SELECT * FROM "PAIS" WHERE "ID_PAIS" LIKE valor;
BEGIN
    dbms_output.put_line('Tabla: '||tabla||', Campo: '||campo||' y Valor: '||valor);
    IF tabla = 'PAIS' AND campo = 'NOMBRE' THEN
        FOR registr IN cursor_registros_nombre LOOP
        dbms_output.put_line('PAIS CON Id:'||registr.ID_PAIS||' EN LA TABLA PAIS ');	
        end loop;
    END IF;
EXCEPTION
WHEN OTHERS THEN
  raise_application_error (-20001, SQLERRM);
END "CONSULTAR_POR_CAMPO";
/
GRANT ALL PRIVILEGES
ON ADMIN_BBDD.CONSULTAR_POR_CAMPO TO admin_BBDD
;
GRANT EXECUTE
ON ADMIN_BBDD.CONSULTAR_POR_CAMPO TO usuario_BBDD
;
