SET serveroutput ON;
SET serveroutput ON size 1000000;
DECLARE
  registro_pais "PAIS"%ROWTYPE;
  registro_poblacion "POBLACION"%ROWTYPE;
  registro_tipo_via "TIPO_VIA"%ROWTYPE;
  registro_direccion "DIRECCION"%ROWTYPE;
  registro_persona "PERSONA"%ROWTYPE;
  registro_trabajador "TRABAJADOR"%ROWTYPE;
  registro_curriculo "CURRICULO"%ROWTYPE;
  registro_tipo_puesto "TIPO_PUESTO"%ROWTYPE;
  registro_puesto "PUESTO"%ROWTYPE;
  registro_idioma "IDIOMA"%ROWTYPE;
  registro_idiomas "IDIOMAS"%ROWTYPE;
  registro_empleo "EMPLEO"%ROWTYPE;
  registro_empresa "EMPRESA"%ROWTYPE;
  registro_entrevista "ENTREVISTA"%ROWTYPE;
  registro_experiencia "EXPERIENCIA"%ROWTYPE;  
  registro_oferta "OFERTA"%ROWTYPE;
  registro NUMBER;
  tabla VARCHAR (50);
  campo VARCHAR (50);
  valor VARCHAR (50);
  fecha DATE;
  fecha_2 DATE;
  
BEGIN
-- Antes de insertar una direccin hay que tener el pas, la poblacin y el tipo de va
	ADMIN_BBDD.INSERTAR_PAIS('ESPAA');
	ADMIN_BBDD.CONSULTAR_PAIS(1,registro_pais);
	dbms_output.put_line('INSERTADO EL PAS ' || registro_pais.nombre||' EN LA TABLA PAIS ');

	ADMIN_BBDD.INSERTAR_POBLACION(17530,'GIRONA',1);
	ADMIN_BBDD.CONSULTAR_POBLACION(17530,registro_poblacion);
	dbms_output.put_line('INSERTADA LA POBLACION ' || registro_poblacion.nombre||' EN LA TABLA POBLACION ');
	
	ADMIN_BBDD.INSERTAR_TIPO_VIA(1,'AVENIDA');
	ADMIN_BBDD.CONSULTAR_TIPO_VIA(1,registro_tipo_via);
	dbms_output.put_line('INSERTADO EL TIPO DE VA ' || registro_tipo_via.descripcion||' EN LA TABLA TIPO_VIA ');

	ADMIN_BBDD.INSERTAR_DIRECCION(1,'CALLE_1','22','2','B',17530);
	ADMIN_BBDD.CONSULTAR_DIRECCION(1,registro_direccion);
	dbms_output.put_line('INSERTADA LA DIRECCIN ' || registro_direccion.nombre||' EN LA TABLA DIRECCION ');
  
-- Antes de insertar una persona hay que insertar la direccin
	ADMIN_BBDD.INSERTAR_PERSONA('11111111A','JOSEP','GUARDIOLA','GUARDIA','josep.guardiola@email.com',666666666,1);
	ADMIN_BBDD.CONSULTAR_PERSONA(1,registro_persona);
	dbms_output.put_line('INSERTADA PERSONA ' || registro_persona.nombre||' '||registro_persona.apellido_1||' EN LA TABLA PERSONA ');
	
-- Antes de insertar un trabajador hay que tener la persona dada de alta
	ADMIN_BBDD.INSERTAR_TRABAJADOR('222222222A',1);
	ADMIN_BBDD.CONSULTAR_TRABAJADOR(1,registro_trabajador);
	dbms_output.put_line('INSERTADO TRABAJADOR CON NASS: ' || registro_trabajador.nass||' EN LA TABLA TRABAJADOR ');
	
-- Para insertar un curriculo hemos de tener dado de alta al trabajador
-- Parmetros fecha, foto e id_Trabajador
	fecha := To_date('01/01/12', 'dd/mm/yy');
	ADMIN_BBDD.INSERTAR_CURRICULO(1,fecha,null);
	ADMIN_BBDD.CONSULTAR_CURRICULO(1,registro_curriculo);
	dbms_output.put_line('INSERTADO CURRICULO CON Id: ' || registro_curriculo.id_curriculo||' EN LA TABLA CURRICULO ');
	
-- Antes de insertar un puesto de empleo tenemos que tener dado de alta el tipo de puesto al que pertenece
	ADMIN_BBDD.INSERTAR_TIPO_PUESTO('GRADUADO');
	ADMIN_BBDD.CONSULTAR_TIPO_PUESTO(1,registro_tipo_puesto);
	dbms_output.put_line('INSERTADO TIPO PUESTO: ' || registro_tipo_puesto.descripcion||' EN LA TABLA TIPO_PUESTO ');
	
-- Antes de insertar un empleo tenemos que tener dado de alta puesto al que corresponde
	ADMIN_BBDD.INSERTAR_PUESTO('INGENIERO DE SISTEMAS',1);
	ADMIN_BBDD.CONSULTAR_PUESTO(1,registro_puesto);
	dbms_output.put_line('INSERTADO PUESTO: ' || registro_puesto.descripcion||' EN LA TABLA PUESTO ');
	
-- Antes de insertar una Empresa tenemos que tener la direccin
-- Parmetros: CIF, nombre, email, teleofno, direccion y la persona responsable
	ADMIN_BBDD.INSERTAR_EMPRESA('cif_1','EMPRESA_1','empresa_1@empresa.com',649999999,1,1);
	ADMIN_BBDD.CONSULTAR_EMPRESA(1,registro_empresa);
	dbms_output.put_line('INSERTADA EMPRESA: ' || registro_empresa.nombre||' EN LA TABLA EMPRESA ');
	
-- Para insertar un empleo tiene que existir la empresa, el currculo y el puesto al que va asociado
-- Parmetros nombre empresa, fecha inicio, fecha fin, id_puesto e id_curriculo
	fecha := To_date('01/01/11', 'dd/mm/yy');
	fecha_2 := To_date('01/01/12', 'dd/mm/yy');
	ADMIN_BBDD.INSERTAR_EMPLEO(1,'01/01/2011','01/01/2012',1,1);
	ADMIN_BBDD.CONSULTAR_EMPLEO(1,registro_empleo);
	dbms_output.put_line('INSERTADO EMPLEO CON Id: ' || registro_empleo.id_empleo||' EN LA TABLA EMPLEO ');

-- Antes de insertar un idioma en el currculo tenemos que tener dado de alta el ididoma en la BBDD
	ADMIN_BBDD.INSERTAR_IDIOMAS('INGLS');
	ADMIN_BBDD.CONSULTAR_IDIOMAS(1,registro_idiomas);
	dbms_output.put_line('INSERTADO IDIOMA: ' || registro_idiomas.descripcion||' EN LA TABLA IDIOMAS ');
	
-- Para insertar un nivel de idioma en el currculo tenemos que tener dado de alta el currculo y el idioma
	ADMIN_BBDD.INSERTAR_IDIOMA('ALTO',1,1);
	ADMIN_BBDD.CONSULTAR_IDIOMA(1,registro_idioma);
	dbms_output.put_line('INSERTADO NIVEL DE IDIOMA: ' || registro_idioma.nivel||' EN LA TABLA IDIOMAS ');

-- Para insertar una oferta de empleo tiene que existir la empresa y el puesto de trabajo 
-- Parmetros remuneracin, prioridad, fecha inicio, fecha adjudicacin, id_puesto e id_empresa
  fecha := To_date('01/01/12', 'dd/mm/yy');
	fecha_2 := To_date('01/02/12', 'dd/mm/yy');
	ADMIN_BBDD.INSERTAR_OFERTA(2000,14,fecha,fecha_2,1,1);
	ADMIN_BBDD.CONSULTAR_OFERTA(1,registro_oferta);
	dbms_output.put_line('INSERTADA OFERTA CON Id: ' || registro_oferta.id_oferta||' EN LA TABLA OFERTA ');
	
-- Para insertar una entrevista tiene que existir la empresa, el trabajador y la oferta a la que va asociada
-- Parmetros fecha , id_oferta e id_trabajador
  fecha := To_date('15/01/12', 'dd/mm/yy');
	ADMIN_BBDD.INSERTAR_ENTREVISTA(fecha,1,1);
	ADMIN_BBDD.CONSULTAR_ENTREVISTA(1,registro_entrevista);
	dbms_output.put_line('INSERTADA ENTREVISTA CON Id: ' || registro_entrevista.id_entrevista||' EN LA TABLA ENTREVISTA ');		
	
-- Para insertar una experiencia exigida en una oferta, primero ha  de existir la oferta
-- Parmetros: id_oferta e id_puesto
	ADMIN_BBDD.INSERTAR_EXPERIENCIA(1,1);
	ADMIN_BBDD.CONSULTAR_EXPERIENCIA(1,registro_experiencia);
	dbms_output.put_line('INSERTADA EXPERIENCIA CON Id: ' || registro_experiencia.id_experiencia||' EN LA TABLA EXPERIENCIA ');	

-- CONSULTA DE LOS REGISTROS DE CUALQUIER TABLA, POR EL VALOR DE UN CAMPO DETERMIMADO
-- Parmetros: nombre de la tabla, nombre del campo, valor del campo
	tabla := 'OFERTA';
	campo := 'remuneracion';
	ADMIN_BBDD.CONSULTAR_POR_CAMPO (tabla,campo,2000);
	
-- Para eliminar un registro de cualquier tabla, basta con dar el identificador de la clave y el nombre de la tabla
	registro := 1;
	tabla := 'PAIS';
	ADMIN_BBDD.ELIMINAR_REGISTRO(registro,tabla);
	dbms_output.put_line('BORRADO REGISTRO CON Id: '|| registro||' EN LA TABLA '||tabla);		

END;
/
COMMIT;